﻿package  
{
	
	import mx.collections.ArrayCollection;
	import Visual.GameSprite;
	
	/**
	 * ...
	 * @author Nicki T. Hansen
	 */
	public class InputMachine 
	{
		public var sprite:GameSprite;
		public var connectedTo:ArrayCollection = new ArrayCollection();
		public var finiteAmountOfBeer:Number = 6000;
		
		public function InputMachine() 
		{
			sprite = new GameSprite( -1, -1, false);
			//sprite.setStartPosition(0,100);
		}
		
		public function addConnection(machine:Machine):void
		{
			connectedTo.addItem(machine);
		}
		
		public function removeConnection(machine:Machine):void
		{
			connectedTo.removeItemAt(connectedTo.getItemIndex(machine));		
		}
		public function enterFrame(seconds:Number):void
		{
			
		}

		public function generateBeers(budget:Number):Number
		{
			var numBeer:Number = 20;
			var spentAmount:Number = 0;
			
			var numberOfConnects:Number = connectedTo.length;
			var cursor:Number = 0;
			if (finiteAmountOfBeer <= 0) 
			{
				//end game
				Controller.Instance.outOfResources();
			}
			if (numberOfConnects != 0)
			{
				for (var i:Number = 0; i < numBeer; i++)
				{
					if (numberOfConnects <= cursor)
					{
						cursor = 0;
					}
					if (spentAmount < budget)
					{
						
						Machine(connectedTo.getItemAt(cursor)).addBeer(new Beer());
						cursor++;
						spentAmount += 3; //beer materials cost
						finiteAmountOfBeer--;
					}
					else
					{
						//end game, lose
						Controller.Instance.outOfMoney();
						break;
					}
				}
			}
			return spentAmount;
			
		}
		
	}
	
}