﻿package  
{
	
	/**
	 * ...
	 * @author Nicki T. Hansen
	 */
	public class Model 
	{
		public var netWorth:Number = 1000;
		public var money:Number = 1000;
		public var incomePerSec:Number = 0;
		public var costPerSec:Number = 0;
		
		
		
		/**
		 * Contains the values for the game
		 */
		public function Model() 
		{
			
		}
		
		public function addIncome(income:Number):void
		{
			income = Math.round(income);
			netWorth += income;
			money += income;
			incomePerSec += income;
		}
		
		//half net worth cost
		public function buyMachine(cost:Number):void
		{
			doPayment(cost);
			//TODO connected to actual machines worth
			netWorth += Math.round(cost / 2);
		}
		
		//no net worth change
		public function sellMachine(income:Number):void
		{
			income = Math.round(income);			
			money += income;
			incomePerSec += income;
		}
		
		
		public function resetIncomePerSec():void 
		{
			incomePerSec = 0;
		}
		public function resetCostPerSec():void
		{
			costPerSec = 0;
		}
		/**
		 * 
		 * @param	cost
		 * @return Boolean true 
		 */
		public function isPaymentPossible(cost:Number):Boolean
		{
			if (cost < money)
			{			
				return true;
			}
			return false;
		}
		
		public function doPayment(cost:Number):void
		{
			money -= cost;			
			costPerSec += cost;
		}		
		
		
	}	
}