﻿package Visual
{
	
	
	import flash.display.*;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Nicki Thomas Hansen
	 */
	public class GraphicsResource 
	{			
		public var sprite:BitmapData = null;
		
		public function GraphicsResource(image:DisplayObject)
		{
			var bitmap:BitmapData = createBitmapData(image);		
			sprite = new BitmapData(image.width, image.height, true);
			sprite.copyPixels(bitmap, bitmap.rect, new Point(0, 0),createAlphaBitmapData(image), new Point(0, 0));
		}
		
		private function createBitmapData(image:DisplayObject):BitmapData
		{
			var bitmap:BitmapData = new BitmapData(image.width, image.height)
			bitmap.draw(image);
			return bitmap;
		}
		
		private function createAlphaBitmapData(image:DisplayObject):BitmapData
		{
			var bitmap:BitmapData = new BitmapData(image.width, image.height);
			bitmap.draw(image, null, null, BlendMode.ALPHA);
			return bitmap;
		}
	}

	
}