﻿package Visual 
{
	import adobe.utils.CustomActions;
	import flash.display.*;	
	import mx.controls.Image;
	/**
	 * ...
	 * @author Nicki Thomas Hansen
	 */
	public final class Resource 
	{	
		[Embed(source = '../media/machines/Mill_Bitter.png')]
		private static var MillBitter:Class;
		[Embed(source = '../media/machines/Mill_Salty.png')]
		public static var MillSalty:Class;
		[Embed(source = '../media/machines/Mill_Sour.png')]
		private static var MillSour:Class;
		[Embed(source = '../media/machines/Mill_Sweet.png')]
		private static var MillSweet:Class;
		[Embed(source = '../media/machines/Mill_Umami.png')]
		public static var MillUmami:Class;
		
		[Embed(source = '../media/machines/Masher_Bitter.png')]
		private static var MasherBitter:Class;
		[Embed(source = '../media/machines/Masher_Salty.png')]
		public static var MasherSalty:Class;
		[Embed(source = '../media/machines/Masher_Sour.png')]
		private static var MasherSour:Class;
		[Embed(source = '../media/machines/Masher_Sweet.png')]
		private static var MasherSweet:Class;
		[Embed(source = '../media/machines/Masher_Umami.png')]
		public static var MasherUmami:Class;
		
		[Embed(source = '../media/machines/Lauter_Bitter.png')]
		private static var LauterBitter:Class;
		[Embed(source = '../media/machines/Lauter_Salty.png')]
		public static var LauterSalty:Class;
		[Embed(source = '../media/machines/Lauter_Sour.png')]
		private static var LauterSour:Class;
		[Embed(source = '../media/machines/Lauter_Sweet.png')]
		private static var LauterSweet:Class;
		[Embed(source = '../media/machines/Lauter_Umami.png')]
		public static var LauterUmami:Class;
		
		[Embed(source = '../media/machines/Boiler_Bitter.png')]
		private static var BoilerBitter:Class;
		[Embed(source = '../media/machines/Boiler_Salty.png')]
		public static var BoilerSalty:Class;
		[Embed(source = '../media/machines/Boiler_Sour.png')]
		private static var BoilerSour:Class;
		[Embed(source = '../media/machines/Boiler_Sweet.png')]
		private static var BoilerSweet:Class;
		[Embed(source = '../media/machines/Boiler_Umami.png')]
		public static var BoilerUmami:Class;		
		[Embed(source = '../media/machines/Fermenter_Bitter.png')]
		private static var FermenterBitter:Class;
		[Embed(source = '../media/machines/Fermenter_Salty.png')]
		public static var FermenterSalty:Class;
		[Embed(source = '../media/machines/Fermenter_Sour.png')]
		private static var FermenterSour:Class;
		[Embed(source = '../media/machines/Fermenter_Sweet.png')]
		private static var FermenterSweet:Class;
		[Embed(source = '../media/machines/Fermenter_Umami.png')]
		public static var FermenterUmami:Class;
		[Embed(source = '../media/machines/Bottler_Bitter.png')]
		private static var BottlerBitter:Class;
		[Embed(source = '../media/machines/Bottler_Salty.png')]
		public static var BottlerSalty:Class;
		[Embed(source = '../media/machines/Bottler_Sour.png')]
		private static var BottlerSour:Class;
		[Embed(source = '../media/machines/Bottler_Sweet.png')]
		private static var BottlerSweet:Class;
		[Embed(source = '../media/machines/Bottler_Umami.png')]
		public static var BottlerUmami:Class;
		
		/*
		 * machineArray[stage][taste]
		 * 
		 * 
		 */
		public static var machineArray:Array = 
		[
		[new GraphicsResource(new MillBitter()), new GraphicsResource(new MillSalty()), new GraphicsResource(new MillSour()),
		new GraphicsResource(new MillSweet()), new GraphicsResource(new MillUmami())],
		[new GraphicsResource(new MasherBitter()), new GraphicsResource(new MasherSalty()), new GraphicsResource(new MasherSour()), 
		new GraphicsResource(new MasherSweet()), new GraphicsResource(new MasherUmami())],
		[new GraphicsResource(new LauterBitter()), new GraphicsResource(new LauterSalty()), new GraphicsResource(new LauterSour()),
		new GraphicsResource(new LauterSweet()), new GraphicsResource(new LauterUmami())],
		[new GraphicsResource(new BoilerBitter()), new GraphicsResource(new BoilerSalty()), new GraphicsResource(new BoilerSour()),
		new GraphicsResource(new BoilerSweet()), new GraphicsResource(new BoilerUmami())],
		[new GraphicsResource(new FermenterBitter()), new GraphicsResource(new FermenterSalty()), new GraphicsResource(new FermenterSour()),
		new GraphicsResource(new FermenterSweet()), new GraphicsResource(new FermenterUmami())],
		[new GraphicsResource(new BottlerBitter()), new GraphicsResource(new BottlerSalty()), new GraphicsResource(new BottlerSour()),
		new GraphicsResource(new BottlerSweet()), new GraphicsResource(new BottlerUmami())],
		];
		
		
		[Embed(source = '../media/veteran/^.png')]
		private static var veteran1:Class;
		public static var veteran1GR:GraphicsResource = new GraphicsResource(new veteran1());
		[Embed(source = '../media/veteran/^^.png')]
		private static var veteran2:Class;
		public static var veteran2GR:GraphicsResource = new GraphicsResource(new veteran2());
		[Embed(source = '../media/veteran/^^^.png')]
		private static var veteran3:Class;
		public static var veteran3GR:GraphicsResource = new GraphicsResource(new veteran3());
		[Embed(source = '../media/veteran/star.png')]
		private static var veteran4:Class;
		public static var veteran4GR:GraphicsResource = new GraphicsResource(new veteran4());
		
		[Embed(source = '../media/RomerTal/I.png')]
		private static var stage1:Class;
		public static var stage1GR:GraphicsResource = new GraphicsResource(new stage1());
		[Embed(source = '../media/RomerTal/II.png')]
		private static var stage2:Class;
		public static var stage2GR:GraphicsResource = new GraphicsResource(new stage2());
		[Embed(source = '../media/RomerTal/III.png')]
		private static var stage3:Class;
		public static var stage3GR:GraphicsResource = new GraphicsResource(new stage3());
		[Embed(source = '../media/RomerTal/IV.png')]
		private static var stage4:Class;
		public static var stage4GR:GraphicsResource = new GraphicsResource(new stage4());
		[Embed(source = '../media/RomerTal/V.png')]
		private static var stage5:Class;
		public static var stage5GR:GraphicsResource = new GraphicsResource(new stage5());
		[Embed(source = '../media/RomerTal/VI.png')]
		private static var stage6:Class;
		public static var stage6GR:GraphicsResource = new GraphicsResource(new stage6());

		[Embed(source = '../media/inputBay.png')]
		private static var input:Class;
		public static var inputGR:GraphicsResource = new GraphicsResource(new input());
		
		[Embed(source='../media/outputBay.png')]
		private static var output:Class;
		public static var outputGR:GraphicsResource = new GraphicsResource(new output());
		
	}
}